VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   3  'Fester Dialog
   Caption         =   "Asymmetrisches Verschlsselungssystem (RSA)"
   ClientHeight    =   4590
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   5610
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4590
   ScaleWidth      =   5610
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows-Standard
   Begin VB.CommandButton Command4 
      Caption         =   "Prfen"
      Height          =   375
      Left            =   3360
      TabIndex        =   15
      Top             =   2280
      Width           =   1695
   End
   Begin VB.TextBox Text6 
      Alignment       =   1  'Rechts
      Height          =   285
      Left            =   3360
      Locked          =   -1  'True
      TabIndex        =   13
      Top             =   3600
      Width           =   1815
   End
   Begin VB.TextBox Text5 
      Alignment       =   1  'Rechts
      Height          =   285
      Left            =   3360
      TabIndex        =   12
      Top             =   3360
      Width           =   1815
   End
   Begin VB.CommandButton Command5 
      Caption         =   "Neu"
      Height          =   375
      Left            =   2280
      TabIndex        =   11
      Top             =   4200
      Width           =   975
   End
   Begin VB.TextBox Text3 
      Alignment       =   1  'Rechts
      Height          =   285
      Left            =   360
      Locked          =   -1  'True
      TabIndex        =   10
      Top             =   3600
      Width           =   1815
   End
   Begin VB.CommandButton Command2 
      Caption         =   "Entschlsseln"
      Height          =   375
      Left            =   360
      TabIndex        =   9
      Top             =   2280
      Width           =   1695
   End
   Begin VB.CommandButton Command3 
      Caption         =   "Authentifizieren"
      Height          =   375
      Left            =   3360
      TabIndex        =   8
      Top             =   1920
      Width           =   1695
   End
   Begin VB.CommandButton Command1 
      Caption         =   "bermitteln"
      Height          =   375
      Left            =   360
      TabIndex        =   7
      Top             =   1920
      Width           =   1695
   End
   Begin VB.TextBox Text4 
      Alignment       =   1  'Rechts
      Height          =   285
      Left            =   3360
      TabIndex        =   6
      Top             =   600
      Width           =   1815
   End
   Begin VB.TextBox Text2 
      Alignment       =   1  'Rechts
      Height          =   285
      Left            =   360
      Locked          =   -1  'True
      TabIndex        =   3
      Top             =   3360
      Width           =   1815
   End
   Begin VB.TextBox Text1 
      Alignment       =   1  'Rechts
      Height          =   285
      Left            =   360
      TabIndex        =   2
      Top             =   600
      Width           =   1815
   End
   Begin VB.Label Label6 
      Alignment       =   2  'Zentriert
      AutoSize        =   -1  'True
      Height          =   195
      Left            =   4200
      TabIndex        =   14
      Top             =   3960
      Width           =   75
   End
   Begin VB.Label Label4 
      Alignment       =   2  'Zentriert
      AutoSize        =   -1  'True
      Height          =   195
      Left            =   1290
      TabIndex        =   5
      Top             =   3960
      Width           =   75
   End
   Begin VB.Label Label3 
      Alignment       =   2  'Zentriert
      AutoSize        =   -1  'True
      Height          =   195
      Left            =   1290
      TabIndex        =   4
      Top             =   960
      Width           =   75
   End
   Begin VB.Label Label2 
      Alignment       =   2  'Zentriert
      Caption         =   "Authentifikation"
      Height          =   255
      Left            =   3000
      TabIndex        =   1
      Top             =   120
      Width           =   2415
   End
   Begin VB.Label Label1 
      Alignment       =   2  'Zentriert
      Caption         =   "Verschlsselung"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   2415
   End
   Begin VB.Line Line2 
      X1              =   0
      X2              =   5640
      Y1              =   480
      Y2              =   480
   End
   Begin VB.Line Line1 
      X1              =   2760
      X2              =   2760
      Y1              =   0
      Y2              =   4200
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Alice As New Party ' Sender
Private Bob   As New Party ' Empfnger

Private Sub Form_Load()
   Call NewKeys
End Sub

Private Sub Command5_Click()
   Call NewKeys
End Sub


Private Sub Command1_Click()
   Dim Plaintext As Long, Encoded As Long
   
   If Val(Text1.Text) >= Bob.N Then
      Call MsgBox("Wert zu hoch", vbCritical)
      Exit Sub
   End If
   
   ' Verschlsseln
   If IsNumeric(Text1.Text) Then
      Plaintext = CLng(Text1.Text)
      Encoded = Encrypt(Plaintext, Bob)
      Text2.Text = CStr(Encoded)
   End If
End Sub

Private Sub Command2_Click()
   Dim Plaintext As Long, Encoded As Long
   
   ' Entschlsseln
   If IsNumeric(Text2.Text) Then
      Encoded = CLng(Text2.Text)
      Plaintext = Bob.Decrypt(Encoded)
      Text3.Text = CStr(Plaintext)
   End If
End Sub


Private Sub Command3_Click()
   Dim Plaintext As Long, Signed As Long
   
   If Alice.TooBig(Val(Text4.Text)) Then
      Call MsgBox("Wert zu hoch", vbCritical)
      Exit Sub
   End If
   
   ' Authentifikationscode erstellen
   If IsNumeric(Text4.Text) Then
      Plaintext = CLng(Text4.Text)
      Signed = Alice.Sign(Plaintext)
      Text5.Text = CStr(Signed)
   End If
End Sub

Private Sub Command4_Click()
   Dim Plaintext As Long, Signature As Long
      
   ' Authentifikation prfen
   If IsNumeric(Text5.Text) Then
      Signature = CLng(Text5.Text)
      Plaintext = GetSignaturePlaintext(Signature, Alice)
      Text6.Text = CStr(Plaintext)
      Label6.Caption = IIf(Text4.Text = Text6.Text, "Authentifikation als Alice erfolgreich", "Nicht authentifiziert")
   End If
End Sub


' Neue Schlssel und auch schonst alles neu
Private Sub NewKeys()
   Call Alice.Initialize
   Call Bob.Initialize
   
   Label3.Caption = "Public-Key: { " & CStr(Alice.e) & " ; " & CStr(Alice.N) & " }"
   Label4.Caption = "Public-Key: { " & CStr(Bob.e) & " ; " & CStr(Bob.N) & " }"
   
   Text1.Text = ""
   Text2.Text = ""
   Text3.Text = ""
   Text4.Text = ""
   Text5.Text = ""
   Text6.Text = ""
End Sub

' NumberOnly-Eingaben prfen
Private Sub Text1_KeyPress(KeyAscii As Integer)
   KeyAscii = IIf(KeyAscii < Asc("0") Or KeyAscii > Asc("9") Xor KeyAscii = 8, 0, KeyAscii)
End Sub
Private Sub Text4_KeyPress(KeyAscii As Integer)
   KeyAscii = IIf(KeyAscii < Asc("0") Or KeyAscii > Asc("9") Xor KeyAscii = 8, 0, KeyAscii)
End Sub
Private Sub Text5_KeyPress(KeyAscii As Integer)
   KeyAscii = IIf(KeyAscii < Asc("0") Or KeyAscii > Asc("9") Xor KeyAscii = 8, 0, KeyAscii)
End Sub
