VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Party"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' Reprsentation einer beteiligten Partei

Private p As Long, q As Long  ' Die Primzahlen
Private d As Long             ' Der Private Key
Private X As Long             ' Eulersche Funktion von N

Public e As Long, N As Long   ' Der Public Key

' Initialisieren
Public Sub Initialize()
   Call Randomize
   
   p = NextPrime(Random(100, 250))     ' Erste Primzahl
   
   Do
      q = NextPrime(Random(100, 250))  ' 2. Primzahl <> 1. Primzahl
   Loop While p = q
   
   N = p * q                           ' ffentlicher Schlssel
   X = (p - 1) * (q - 1)               ' Eulersche Funktion von N
   
   e = CoPrime(X)                      ' Teilerfremde Zahl e zu X
   d = EuklidEx(e, X)                  ' d * e = 1 (mod X)
   
   p = 0 ' Brauchen wir nicht mehr
   q = 0 ' Das auch nicht
End Sub

' Nachricht entschlsseln
Public Function Decrypt(Message As Long) As Long
   Decrypt = ModExp(Message, d, N)
End Function

' Nachricht signieren
Public Function Sign(Message As Long) As Long
   Sign = ModExp(Message, d, N)
End Function

' Muss sein ;-)
Public Function TooBig(Plaintext As Long) As Boolean
   TooBig = (Plaintext >= d)
End Function
